day28【LeetCode力扣】383.赎金信
以后我们每期附张图啦~~~
1.题目描述
附上题目链接:赎金信
给你两个字符串:ransomNote
和 magazine
,判断 ransomNote
能不能由 magazine
里面的字符构成。
如果可以,返回 true
;否则返回 false
。
magazine
中的每个字符只能在 ransomNote
中使用一次。
示例 1:
输入:ransomNote = "a", magazine = "b"
输出:false
示例 2:
输入:ransomNote = "aa", magazine = "ab"
输出:false
示例 3:
输入:ransomNote = "aa", magazine = "aab"
输出:true
2.题解
这题和day22的242.有效的字母异位词很类似,只不过这题是一串字母能组成另一串,不用管对方。
c++
1.先上暴力解法吧~!
class Solution {
public:
bool canConstruct(string ransomNote, string magazine) {
for (int i = 0; i < magazine.length(); i++) {
for (int j = 0; j < ransomNote.length(); j++) {
// 在ransomNote中找到和magazine相同的字符
if (magazine[i] == ransomNote[j]) {
ransomNote.erase(ransomNote.begin() + j); // ransomNote删除这个字符
break;
}
}
}
// 如果ransomNote为空,则说明magazine的字符可以组成ransomNote
if (ransomNote.length() == 0) {
return true;
}
return false;
}
};
2.使用map
首先我们能想到的就是使用哈希法(使用map),将字母出现的次数记录下来,然后比对,代码如下:
class Solution {
public:
bool canConstruct(string ransomNote, string magazine) {
unordered_map<char,int> imp;
for(auto i : magazine){
imp[i]++;
}
for(auto i : ransomNote){
if(imp[i] == 0)
return false;
imp[i]--;
}
return true;
}
};
但是这种解法是最优的吗?
3.使用数组
基于本题的情况下,使用map的空间消耗要比数组大一些,因为map要维护红黑树或者哈希表,而且还要做哈希函数,是比较费时的!数据量大的话就能体现出来差别了。 所以数组更加简单直接有效!代码如下:
class Solution {
public:
bool canConstruct(string ransomNote, string magazine) {
int record[26] = {0};
if (ransomNote.size() > magazine.size()) {
return false;
}
for (int i = 0; i < magazine.length(); i++) {
// 通过record数据记录 magazine里各个字符出现次数
record[magazine[i]-'a'] ++;
}
for (int j = 0; j < ransomNote.length(); j++) {
// 遍历ransomNote,在record里对应的字符个数做--操作
record[ransomNote[j]-'a']--;
// 如果小于零说明ransomNote里出现的字符,magazine没有
if(record[ransomNote[j]-'a'] < 0) {
return false;
}
}
return true;
}
};
python
1.使用数组
class Solution:
def canConstruct(self, ransomNote: str, magazine: str) -> bool:
res1 = [0]*26
for c in magazine:
res1[ord(c)-ord('a')] += 1
for c in ransomNote:
res1[ord(c)-ord('a')] -= 1
if res1[ord(c)-ord('a')] < 0:
return False
return True
2.使用defaultdict
class Solution:
def canConstruct(self, ransomNote: str, magazine: str) -> bool:
hasmap = defaultdict(int)
for c in magazine:
hasmap[c] += 1
for c in ransomNote:
value = hasmap.get(c)
if not value :
return False
else:
hasmap[c] -= 1
return True
3.使用字典
class Solution:
def canConstruct(self, ransomNote: str, magazine: str) -> bool:
counts = {}
for c in magazine:
counts[c] = counts.get(c,0) + 1
for c in ransomNote:
if c not in counts or counts[c] == 0:
return False
counts[c] -= 1
return True
4.使用Counter
class Solution:
def canConstruct(self, ransomNote: str, magazine: str) -> bool:
return not Counter(ransomNote) - Counter(magazine)
5.使用count
class Solution:
def canConstruct(self, ransomNote: str, magazine: str) -> bool:
return all(ransomNote.count(c) <= magazine.count(c) for c in set(ransomNote))
ok了,就到这里叭~~~
如果觉得作者写的不错,求给博主一个大大的点赞支持一下,你们的支持是我更新的最大动力!
如果觉得作者写的不错,求给博主一个大大的点赞支持一下,你们的支持是我更新的最大动力!
如果觉得作者写的不错,求给博主一个大大的点赞支持一下,你们的支持是我更新的最大动力!